//+------------------------------------------------------------------+
//|                 Multi_Pair_Average_Range_Scanner_Alerts_v1.0.mq4 |
//|                                         Copyright 2020, NickBixy |
//|             https://www.forexfactory.com/showthread.php?t=904734 |
//+------------------------------------------------------------------+
#property copyright "NickBixy"
#property link      "https://www.forexfactory.com/showthread.php?t=904734"
//#property version   "1.0"
#property strict
#property indicator_chart_window
#define HR2400 (PERIOD_D1 * 60)

ENUM_TIMEFRAMES TFMigrate(int tf)
  {
   switch(tf)
     {
      case 0:
         return(PERIOD_CURRENT);
      case 1:
         return(PERIOD_M1);
      case 5:
         return(PERIOD_M5);
      case 15:
         return(PERIOD_M15);
      case 30:
         return(PERIOD_M30);
      case 60:
         return(PERIOD_H1);
      case 240:
         return(PERIOD_H4);
      case 1440:
         return(PERIOD_D1);
      case 10080:
         return(PERIOD_W1);
      case 43200:
         return(PERIOD_MN1);

      case 2:
         return(PERIOD_M2);
      case 3:
         return(PERIOD_M3);
      case 4:
         return(PERIOD_M4);
      case 6:
         return(PERIOD_M6);
      case 10:
         return(PERIOD_M10);
      case 12:
         return(PERIOD_M12);
      case 16385:
         return(PERIOD_H1);
      case 16386:
         return(PERIOD_H2);
      case 16387:
         return(PERIOD_H3);
      case 16388:
         return(PERIOD_H4);
      case 16390:
         return(PERIOD_H6);
      case 16392:
         return(PERIOD_H8);
      case 16396:
         return(PERIOD_H12);
      case 16408:
         return(PERIOD_D1);
      case 32769:
         return(PERIOD_W1);
      case 49153:
         return(PERIOD_MN1);
      default:
         return(PERIOD_CURRENT);
     }
  }


enum yesnoChoiceToggle
  {
   No,
   Yes
  };

enum pipPointChoice
  {
   Pips,//Pips
   Points,//Points
  };

enum symbolTypeChoice
  {
   MarketWatch,//Market Watch
   SymbolList//Symbols In List
  };

enum timeChoice
  {
   Server,
   Local
  };

input string info="Put Scanner On A Separate Chart Tab From Trading Strategy";//Put Scanner On A Separate Chart Tab From Trading Stategy
input string indiLink="https://www.forexfactory.com/showthread.php?t=904734";//Indicator's Thread On Forex Factory
input int refreshTime=5;//Refresh Check Every X Seconds

input string adrHeader="-----------------Average Range Settings------------------------------------------";//----- Average Range Settings
input ENUM_TIMEFRAMES timeFrame=PERIOD_D1;//TimeFrame Period?
input int avgRangeNumPeriod=10;//Num APR Period? (Average Period Range)
input pipPointChoice pipPointSelection=Pips;//Pips/Points?

input string symbolHeader="-----------------Symbol Settings------------------------------------------";//----- Symbol Settings
input symbolTypeChoice symTypeChoice=MarketWatch;//Symbols To Scan-Market Watch/Symbol List Below?
input string symbols="AUDCAD,AUDCHF,AUDJPY,AUDNZD,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURJPY,EURNZD,EURUSD,GBPAUD,GBPCAD,GBPCHF,GBPJPY,GBPNZD,GBPUSD,NZDCAD,NZDCHF,NZDJPY,NZDUSD,USDCAD,USDCHF,USDJPY"; //Symbols To Scan
input string symbolPrefix=""; //Symbol Prefix
input string symbolSuffix=""; //Symbol Suffix

input string AlertHeader="-----------------Alert Settings--------------------------------------";//----- Alert Settings
input yesnoChoiceToggle useCrossAlerts=Yes;//Cross Alerts? - Alert Bid Price Cross High/Low
input yesnoChoiceToggle usePercentAlerts=Yes;//Percent Alerts? - Alert Percent Reached
input double percentageValueAlert=100.00;//Percent Value
input int alertInternalMinutes=30;//Alert Wait Time In Min for same Pivot alert Msg
input yesnoChoiceToggle popupAlerts=Yes;//Use Popup Alerts?
input yesnoChoiceToggle notificationAlerts=Yes;//Use Notification Alerts?
input yesnoChoiceToggle emailAlerts=No;//Use Email Alerts?

input string dashBoardHeader="-----------------Dashboard Settings--------------------------------------";//----- Dashboard Settings
input yesnoChoiceToggle useDashboard=Yes;//Use DashBoard?
input timeChoice timeChoiceOption=Server;//Local/Server Time For Time Last Alert?
input yesnoChoiceToggle roundNearest=Yes;//Rounded Off To The Nearest Integer?
input int decimalPlaces=0;//Number Of Digits After Decimal Point (0-8).
input string positionHeader="Position Label Settings--------------------------------------------";//----- Position Label Settings
input int widthX=28;//X Dashboard +Moves Right, -Moves Left
input int widthY=28;//Y Dashboard +Moves Down, -Moves Up
input int xSxA=70;//X Width Between Symbol-APR
input int xAxC=45;//X Width Between APR-Curr
input int xCxP=45;//X Width Between Curr-Percent
input int xPxN=60;//X Width Between Percent-Near
input int xNxD=40;//X Width Between Near-Dis
input int xDxA=60;//X Width Between Dis-Alert
input int xAxT=60;//X Width Between Alert-Time Last Alert

input string labelHeader="Label Settings--------------------------------------------";//----- Label Settings
input string FontHeader="Arial Bold";//Font Of The Headers
input string Font="Arial";//Font Of The Labels
input int fontText=9;//Font Size Labels
input int textH=14;//Y Spacing Between Rows
input color headerColors=clrViolet;//Color Of Header
input color symbolColor=clrWhite;//Color Of Symbol Labels
input color aprColor=clrYellow;//Color Of APR Labels
input color curRColor=clrYellow;//Color Of CurR Labels
input color percentColor=clrYellow;//Color Of Percent Labels
input color nearColor=clrYellow;//Color Of Near Labels
input color distanceColor=clrYellow;//Color Of Distance Labels
input color alertColor=clrWhite;//Color Of Alert Labels
input color timeLastAlertColor=clrWhite;//Color Of Time Last Alert Labels
input color listLabelColor=clrWhite;//Color List Of Recent Alerts Label

input string percentHeader="Percent Label Settings--------------------------------------------";//----- Percent Label Settings
input yesnoChoiceToggle useCustumPercentColors=Yes;//Use Custom Color By Certain Percentage?
input double percent1      =00.00;//Percent 1 Greater Than
input color  percent1Clr   =clrLime;//Percent 1 Color
input double percent2      =25.00;//Percent 2 Greater Than
input color  percent2Clr   =clrYellow;//Percent 2 Color
input double percent3      =50.00;//Percent 3 Greater Than
input color  percent3Clr   =clrOrange;//Percent 3 Color
input double percent4      =75.00;//Percent 4 Greater Than
input color  percent4Clr   =clrOrangeRed;//Percent 4 Color
input double percent5      =100.00;//Percent 5 Greater Than
input color  percent5Clr   =clrRed;//Percent 5 Color
input int listLabelSize=20;//Num Of Alert Msg In List Below
input ENUM_TIMEFRAMES openChartTimeFrame=PERIOD_H1;//Open Chart TimeFrame

string listLabelNames[];
string timeFrameShortName="";
string indiName="MPARSA"+EnumToString(timeFrame)+(string)avgRangeNumPeriod;
int alertIntervalTimeSeconds; //Wait Time Between Same Alert Message
int numSymbols=0; //The Number Of Symbols To Scan
string symbolList[]; //Array Of Symbols
string symbolListFinal[]; //Array Of Symbols After Merging Post And Prefix
int textHEnd=0;

double symbolsRangeHiLoValues[][2];
datetime symbolsWaitTills[][2];
bool symbolsCrossFlags[][2];
bool symbolsRatioFlags[][1];
//+------------------------------------------------------------------+
int OnInit()
  {
//Set Refresh Time
   if(EventSetTimer(refreshTime)==false)
     {
      Alert("Event Set Timer - ERROR CODE: "+(string)GetLastError());
     }
   if(IndicatorSetString(INDICATOR_SHORTNAME,indiName)==false)
     {
      Alert("Indicator Set String - ERROR CODE: "+(string)GetLastError());
     }
   ObjectsDeleteAll(0,indiName,0,-1) ;

   if(alertInternalMinutes<0)
     {
      Alert("Error Alert Wait Time In Min for same Pivot alert Msg <0");
     }
   alertIntervalTimeSeconds=alertInternalMinutes*60;//waiting time between alerts

   if(symTypeChoice==MarketWatch)
     {
      int numSymbolsMarketWatch=SymbolsTotal(true);
      numSymbols=numSymbolsMarketWatch;
      ArrayResize(symbolListFinal,numSymbolsMarketWatch);
      for(int i=0; i<numSymbolsMarketWatch; i++)
        {
         symbolListFinal[i]=SymbolName(i,true);
        }
     }
   else
      if(symTypeChoice==SymbolList)
        {
         getSymbols();//converts the symbol string to list of symbols
        }
   if(testSymbols())//checks if all symbols exits, if not removes indicator from chart and alert message
     {
      ArrayResize(symbolsRangeHiLoValues,numSymbols);
      ArrayResize(symbolsWaitTills,numSymbols);
      ArrayResize(symbolsCrossFlags,numSymbols);
      ArrayResize(symbolsRatioFlags,numSymbols);

      for(int i=0; i<numSymbols; i++)
        {
         symbolsRangeHiLoValues[i][0]=NULL;
         symbolsRangeHiLoValues[i][1]=NULL;

         symbolsWaitTills[i][0]=NULL;
         symbolsWaitTills[i][1]=NULL;

         symbolsCrossFlags[i][0]=NULL;
         symbolsCrossFlags[i][1]=NULL;

         symbolsRatioFlags[i][0]=NULL;
        }

      if(useDashboard==Yes)
        {
         CreateLabels();
        }

      switch(timeFrame)
        {
         case PERIOD_M1:
           {
            timeFrameShortName="M1";
            break;
           }
         case PERIOD_M5:
           {
            timeFrameShortName="M5";
            break;
           }
         case PERIOD_M15:
           {
            timeFrameShortName="M15";
            break;
           }
         case PERIOD_M30:
           {
            timeFrameShortName="M30";
            break;
           }
         case PERIOD_H1:
           {
            timeFrameShortName="H1";
            break;
           }
         case PERIOD_H4:
           {
            timeFrameShortName="H4";
            break;
           }
         case PERIOD_D1:
           {
            timeFrameShortName="D1";
            break;
           }
         case PERIOD_W1:
           {
            timeFrameShortName="W1";
            break;
           }
         case PERIOD_MN1:
           {
            timeFrameShortName="MN1";
            break;
           }
        }
     }
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
void  OnDeinit(const int  reason)
  {
   ObjectsDeleteAll(0,indiName,0,-1) ;
   Print(__FUNCTION__," Deinitialization reason code = ",reason);
  }
//main loop to check for alert conditions every xx seconds
void OnTimer()//this one loops every x seconds checking each symbol for the alert conditions or when new day to refresh new pivot point values
  {
//check each symbol if thier is a new day , if true recalculate pivot points
   for(int symbolIndex=0; symbolIndex<numSymbols; symbolIndex++)
     {
      if(!download_history(symbolListFinal[symbolIndex],timeFrame))
        {
         continue;
        }
      else
        {
         //this if statement is to prevent getting values before chart is fully downloaded
         if(iHigh(symbolListFinal[symbolIndex], timeFrame,0)==0    ||
            iHigh(symbolListFinal[symbolIndex], timeFrame,0)==NULL ||
            iTime(symbolListFinal[symbolIndex], timeFrame, 0)==0   ||
            iTime(symbolListFinal[symbolIndex], timeFrame, 0)==NULL
           )
           {
            continue;
           }
         else
           {
            if(useCrossAlerts==Yes)
              {
               double rangeHigh=GetAverageRangeHigh(symbolListFinal[symbolIndex]);
               double rangeLow=GetAverageRangeLow(symbolListFinal[symbolIndex]);

               if(rangeHigh!=symbolsRangeHiLoValues[symbolIndex][0])
                 {
                  symbolsRangeHiLoValues[symbolIndex][0]=rangeHigh;
                  symbolsWaitTills[symbolIndex][0]=NULL;
                  symbolsCrossFlags[symbolIndex][0]=NULL;
                  SetCrossFlag(symbolIndex,0);
                 }
               if(rangeLow!=symbolsRangeHiLoValues[symbolIndex][1])
                 {
                  symbolsRangeHiLoValues[symbolIndex][1]=rangeLow;
                  symbolsWaitTills[symbolIndex][1]=NULL;
                  symbolsCrossFlags[symbolIndex][1]=NULL;
                  SetCrossFlag(symbolIndex,1);
                 }
               CheckCrossFlag(symbolIndex);
              }

            if(usePercentAlerts==Yes)
              {
               CheckPercentFlag(symbolIndex);
              }
            if(useDashboard==Yes)
              {
               UpdateLabels(symbolListFinal[symbolIndex],symbolIndex);
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//gets the symbol if using list
void getSymbols()//method extracts the symbols from the string turns it to a list then adds on the correct prefix and suffix so can find symbols
  {
   string sep=",";
   ushort u_sep;
   u_sep=StringGetCharacter(sep,0);
   StringSplit(symbols,u_sep,symbolList);
   numSymbols=ArraySize(symbolList);//get the number of how many symbols are in the symbolList array
   ArrayResize(symbolListFinal,numSymbols);//resize finals symbol list to correct size
   for(int i=0; i<numSymbols; i++) //combines postfix , symbol , prefix names together
     {
      symbolListFinal[i]=symbolPrefix+symbolList[i]+symbolSuffix;
     }
  }
//test the symbols to make sure it can find them
bool testSymbols()//try to find all the symbols from list if not error message
  {
   bool result=true;
   for(int i=0; i<numSymbols; i++)
     {
      double bid=SymbolInfoDouble(symbolListFinal[i],SYMBOL_BID);
      if(GetLastError()==4106) // unknown symbol
        {
         result=false;
         Alert("Can't find this symbol: "+symbolListFinal[i]+",\nPut symbols in Market Watch,\nDouble Check Prefix Or Suffix Settings,\nREMOVING INDICATOR FROM CHART.");

         ChartIndicatorDelete(0,0,indiName);
         break;
        }
     }
   return result;
  }
//+------------------------------------------------------------------+
void CreateLabels()
  {
   string timeOfAlertOption=NULL;
   if(timeChoiceOption==Local)
     {
      timeOfAlertOption="(L)";
     }
   else
      if(timeChoiceOption==Server)
        {
         timeOfAlertOption="(S)";
        }
//create headers
   LabelCreate(0,indiName+" infoH ",0,           widthX,widthY-textH,                              CORNER_LEFT_UPPER,EnumToString(timeFrame)+"-APR("+(string)avgRangeNumPeriod+")-"+EnumToString(pipPointSelection)+"-"+"CA("+EnumToString(useCrossAlerts)+")"+"-"+"PA("+EnumToString(usePercentAlerts)+")"+"-PV("+DoubleToString(percentageValueAlert,decimalPlaces)+")"+"-Round("+EnumToString(roundNearest)+")",FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
   LabelCreate(0,indiName+" symbolH ",0,         widthX,widthY,                                    CORNER_LEFT_UPPER,"Symbol",FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
   LabelCreate(0,indiName+" aprH ",0,            widthX+xSxA,widthY,                               CORNER_LEFT_UPPER,"APR",FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
   LabelCreate(0,indiName+" currentH ",0,        widthX+xSxA+xAxC,widthY,                          CORNER_LEFT_UPPER,"CurR",FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
   LabelCreate(0,indiName+" percentH ",0,        widthX+xSxA+xAxC+xCxP,widthY,                     CORNER_LEFT_UPPER,"Percent",FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
   LabelCreate(0,indiName+" nearH ",0,           widthX+xSxA+xAxC+xCxP+xPxN,widthY,                CORNER_LEFT_UPPER,"Near",FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
   LabelCreate(0,indiName+" distanceH ",0,       widthX+xSxA+xAxC+xCxP+xPxN+xNxD,widthY,           CORNER_LEFT_UPPER,"Distance",FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
   LabelCreate(0,indiName+" alertedH ",0,        widthX+xSxA+xAxC+xCxP+xPxN+xNxD+xDxA,widthY,      CORNER_LEFT_UPPER,"Alert",FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
   LabelCreate(0,indiName+" timeLastAlertH ",0,  widthX+xSxA+xAxC+xCxP+xPxN+xNxD+xDxA+xAxT,widthY, CORNER_LEFT_UPPER,"Time Last Alert"+timeOfAlertOption,FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
   int textSpaceing=textH;

   for(int i=0; i<ArraySize(symbolListFinal); i++)
     {
      LabelCreate(0,indiName+" "+symbolListFinal[i]+" symbolL ",0,         widthX,widthY+textSpaceing,                                    CORNER_LEFT_UPPER,symbolListFinal[i],Font,fontText,symbolColor,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
      LabelCreate(0,indiName+" "+symbolListFinal[i]+" aprL ",0,            widthX+xSxA,widthY+textSpaceing,                               CORNER_LEFT_UPPER,"",Font,fontText,aprColor,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
      LabelCreate(0,indiName+" "+symbolListFinal[i]+" currentL ",0,        widthX+xSxA+xAxC,widthY+textSpaceing,                          CORNER_LEFT_UPPER,"",Font,fontText,curRColor,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
      LabelCreate(0,indiName+" "+symbolListFinal[i]+" percentL ",0,        widthX+xSxA+xAxC+xCxP,widthY+textSpaceing,                     CORNER_LEFT_UPPER,"",Font,fontText,percentColor,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
      LabelCreate(0,indiName+" "+symbolListFinal[i]+" nearL ",0,           widthX+xSxA+xAxC+xCxP+xPxN,widthY+textSpaceing,                CORNER_LEFT_UPPER,"",Font,fontText,nearColor,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
      LabelCreate(0,indiName+" "+symbolListFinal[i]+" distanceL ",0,       widthX+xSxA+xAxC+xCxP+xPxN+xNxD,widthY+textSpaceing,           CORNER_LEFT_UPPER,"",Font,fontText,distanceColor,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
      LabelCreate(0,indiName+" "+symbolListFinal[i]+" alertedL ",0,        widthX+xSxA+xAxC+xCxP+xPxN+xNxD+xDxA,widthY+textSpaceing,      CORNER_LEFT_UPPER,"",Font,fontText,alertColor,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
      LabelCreate(0,indiName+" "+symbolListFinal[i]+" timeLastAlertL ",0,  widthX+xSxA+xAxC+xCxP+xPxN+xNxD+xDxA+xAxT,widthY+textSpaceing, CORNER_LEFT_UPPER,"",Font,fontText,timeLastAlertColor,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);

      textSpaceing+=textH;
     }

   textHEnd=textSpaceing+textH;
   LabelCreate(0,indiName+" listAlertsH ",0,widthX,widthY+textHEnd,CORNER_LEFT_UPPER,"List Of Recent Alerts",FontHeader,fontText,headerColors,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);

   textSpaceing=textH;

   ArrayResize(listLabelNames,listLabelSize);
   for(int p=0; p<ArraySize(listLabelNames); p++)
     {
      listLabelNames[p]=(string)p;
     }
   for(int k=0; k<ArraySize(listLabelNames); k++)
     {
      LabelCreate(0,indiName+" "+listLabelNames[k],0,widthX,widthY+textHEnd+textSpaceing,CORNER_LEFT_UPPER,"",Font,fontText,listLabelColor,0.0,ANCHOR_LEFT_UPPER,false,false,true,0);
      textSpaceing+=textH;
     }
  }
//+------------------------------------------------------------------+
bool LabelCreate(const long              chart_ID=0,               // chart's ID
                 const string            name="Label",             // label name
                 const int               sub_window=0,             // subwindow index
                 const int               x=0,// X coordinate
                 const int               y=0,                      // Y coordinate
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // chart corner for anchoring
                 const string            text="Label",             // text
                 const string            font="Arial",             // font
                 const int               font_size=10,             // font size
                 const color             clr=clrRed,               // color
                 const double            angle=0.0,                // text slope
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, // anchor type
                 const bool              back=false,               // in the background
                 const bool              selection=false,          // highlight to move
                 const bool              hidden=true,              // hidden in the object list
                 const long              z_order=0)                // priority for mouse click
  {
//--- reset the error value
   ResetLastError();
//--- create a text label
   if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ": failed to create text label! Error code = ",GetLastError());
      return(false);
     }
//--- set label coordinates
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//--- set the chart's corner, relative to which point coordinates are defined
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//--- set the text
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//--- set text font
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//--- set font size
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//--- set the slope angle of the text
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//--- set anchor type
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//--- set color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- enable (true) or disable (false) the mode of moving the label by mouse
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//use to force symbols to download lastest chart data
bool download_history(string symbol, ENUM_TIMEFRAMES period=PERIOD_CURRENT)
  {
   if(period == PERIOD_CURRENT)
      period = (ENUM_TIMEFRAMES)_Period;
   ResetLastError();
   datetime other = iTime(symbol, period, 0);
   if(_LastError == 0 && other != 0)
      return true;
   if(_LastError != ERR_HISTORY_NOT_FOUND)
      PrintFormat("iTime(%s,%i) Failed: %i", symbol, period, _LastError);
   return false;
  }
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+
double GetBidAverageRangeDistancePipsPoints(double rangeValue,string symbolName)
  {
   double value=0;
   double bid=SymbolInfoDouble(symbolName,SYMBOL_BID);
   double points=SymbolInfoDouble(symbolName,SYMBOL_POINT);

   if(bid!=0 && bid!=NULL)
     {
      value=(rangeValue-bid)/points;
     }


   if(pipPointSelection==Pips)
     {
      if(value!=0 && value!=NULL)
        {
         value=value/PipsToPointFactor(symbolName);
        }

     }

   if(roundNearest==Yes)
     {
      value=MathRound(value);
     }

   return value;
  }
//+------------------------------------------------------------------+
double GetAverageRangeRatioPipsPoints(string symbolName)
  {
   double value=0;

   double todayRange=GetTodayRangePipsPoints(symbolName);
   double averageRangeNumPeriods=GetAverageRangeNumPeriodsPipsPoints(symbolName);

   if(todayRange!=0 && todayRange!=NULL && averageRangeNumPeriods!=0 && averageRangeNumPeriods!=NULL)
     {
      value=(todayRange/averageRangeNumPeriods)*100;
     }

   if(roundNearest==Yes)
     {
      value=MathRound(value);
     }

   return value;
  }
//+------------------------------------------------------------------+
int PipsToPointFactor(string symbolName)
  {
   int point=1;

   if(SymbolInfoInteger(symbolName,SYMBOL_DIGITS)==5 || SymbolInfoInteger(symbolName,SYMBOL_DIGITS)==3)
     {
      point=10; //1 pip to 10 point if 5 digit
     } //Check whether it's a 5 digit broker (3 digits for Yen)
   else
      if(SymbolInfoInteger(symbolName,SYMBOL_DIGITS)==4 || SymbolInfoInteger(symbolName,SYMBOL_DIGITS)==2 || SymbolInfoInteger(symbolName,SYMBOL_DIGITS)==1)
        {
         point=1; //1 pip to 1 point if 4 digit
        }     

   return(point);
  }
//+------------------------------------------------------------------+
double GetAverageRangeNumPeriodsPipsPoints(string symbolName)
  {
   double value=GetAverageRangeNumPeriods(symbolName);
   double points=SymbolInfoDouble(symbolName,SYMBOL_POINT);

   if(value!=0 && value!=NULL && points!=0 && points!=NULL)
     {
      value=value/points;
     }


   if(pipPointSelection==Pips)
     {
      if(value!=0 && value!=NULL)
        {
         value=value/PipsToPointFactor(symbolName);
        }
     }

   if(roundNearest==Yes)
     {
      value=MathRound(value);
     }

   return value;
  }
//+------------------------------------------------------------------+
double GetTodayRangePipsPoints(string symbolName)
  {
   double value=0;
   double points=SymbolInfoDouble(symbolName,SYMBOL_POINT);
   double high=iHigh(symbolName,timeFrame,0);
   double low=iLow(symbolName,timeFrame,0);
   value=MathAbs(high-low);

   if(value!=0 && value!=NULL)
     {
      value=value/points;
     }


   if(pipPointSelection==Pips)
     {
      if(value!=0 && value!=NULL)
        {
         value=value/PipsToPointFactor(symbolName);
        }
     }

   if(roundNearest==Yes)
     {
      value=MathRound(value);
     }

   return value;
  }
//+------------------------------------------------------------------+
double GetAverageRangeNumPeriods(string symbolName)
  {
   double result=0;
   double averageRange=0;
   for(int i=1; i<=avgRangeNumPeriod; i++)
     {
      double high=iHigh(symbolName,timeFrame,i);
      double low=iLow(symbolName,timeFrame,i);
      averageRange+=high-low;
     }
   return result=averageRange/avgRangeNumPeriod;
  }
//+------------------------------------------------------------------+
double GetTimeFrameHighestHigh(string symbolName)
  {
   return iHigh(symbolName,timeFrame,0);
  }
//+------------------------------------------------------------------+
double GetTimeFrameLowestLow(string symbolName)
  {
   return iLow(symbolName,timeFrame,0);
  }
//+------------------------------------------------------------------+
double GetAverageRangeHigh(string symbolName)
  {
   double todayHigh=iHigh(symbolName,timeFrame,0);
   double todayLow=iLow(symbolName,timeFrame,0);
   double rangeHigh=GetTimeFrameLowestLow(symbolName)+GetAverageRangeNumPeriods(symbolName);
   double averageRange=GetAverageRangeNumPeriods(symbolName);
   if(todayHigh - todayLow > averageRange)
     {
      if(SymbolInfoDouble(symbolName,SYMBOL_BID) >= todayHigh- (todayHigh-todayLow)/2)
        {
         rangeHigh = todayLow + averageRange;
        }
      else
        {
         rangeHigh  = todayHigh;
        }
     }
   return rangeHigh;
  }
//+------------------------------------------------------------------+
double GetAverageRangeLow(string symbolName)
  {
   double todayHigh=iHigh(symbolName,timeFrame,0);
   double todayLow=iLow(symbolName,timeFrame,0);
   double rangeLow=GetTimeFrameHighestHigh(symbolName)-GetAverageRangeNumPeriods(symbolName);
   double averageRange=GetAverageRangeNumPeriods(symbolName);

   if(todayHigh - todayLow > averageRange)
     {
      if(SymbolInfoDouble(symbolName,SYMBOL_BID) >= todayHigh- (todayHigh-todayLow)/2)
        {
         rangeLow  = todayLow;
        }
      else
        {
         rangeLow = todayHigh - averageRange;
        }
     }
   return rangeLow;
  }
//+------------------------------------------------------------------+
void UpdateLabels(string symbolName,int symbolIndex)
  {
   UpdateAPRLabel(symbolName);
   UpdateCurr(symbolName);
   UpdatePer(symbolName);
   UpdateNear(symbolIndex);
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
void UpdateAPRLabel(string symbolName)
  {
   string value=DoubleToString(GetAverageRangeNumPeriodsPipsPoints(symbolName),decimalPlaces);
   ObjectSetTextMQL4(indiName+" "+symbolName+" aprL ",value,fontText,Font,aprColor);
  }
//+------------------------------------------------------------------+
void UpdateCurr(string symbolName)
  {
   string value=DoubleToString(GetTodayRangePipsPoints(symbolName),decimalPlaces);
   ObjectSetTextMQL4(indiName+" "+symbolName+" currentL ",value,fontText,Font,curRColor);
  }
//+------------------------------------------------------------------+
void UpdatePer(string symbolName)
  {
   double percentValue=GetAverageRangeRatioPipsPoints(symbolName);
   string value=DoubleToString(percentValue,decimalPlaces)+"%";

   color labelColor=percentColor;

   if(useCustumPercentColors==Yes)
     {
      if(percentValue>=percent1)
        {
         labelColor=percent1Clr;
        }
      if(percentValue>=percent2)
        {
         labelColor=percent2Clr;
        }
      if(percentValue>=percent3)
        {
         labelColor=percent3Clr;
        }
      if(percentValue>=percent4)
        {
         labelColor=percent4Clr;
        }
      if(percentValue>=percent5)
        {
         labelColor=percent5Clr;
        }
     }
   ObjectSetTextMQL4(indiName+" "+symbolName+" percentL ",value,fontText,Font,labelColor);
  }
//+------------------------------------------------------------------+
void UpdateNear(int symbolIndex)
  {
   double bidPrice=SymbolInfoDouble(symbolListFinal[symbolIndex],SYMBOL_BID);
   double otherCompares=0;
   int smallestIndex=0;
   double currentSmallest=MathAbs(bidPrice-symbolsRangeHiLoValues[symbolIndex][0]);//high

   otherCompares=MathAbs(bidPrice-symbolsRangeHiLoValues[symbolIndex][1]);
   if(otherCompares<currentSmallest)
     {
      currentSmallest=otherCompares;
      smallestIndex=1;
     }

   string adrLevel="";
   string distance="";
   if(smallestIndex==0)
     {
      adrLevel="High";
      distance=DoubleToString(GetBidAverageRangeDistancePipsPoints(GetAverageRangeHigh(symbolListFinal[symbolIndex]),symbolListFinal[symbolIndex]),decimalPlaces);
     }
   else
      if(smallestIndex==1)
        {
         adrLevel="Low";
         distance=DoubleToString(GetBidAverageRangeDistancePipsPoints(GetAverageRangeLow(symbolListFinal[symbolIndex]),symbolListFinal[symbolIndex]),decimalPlaces);
        }

   ObjectSetTextMQL4(indiName+" "+symbolListFinal[symbolIndex]+" nearL ",adrLevel,fontText,Font,nearColor);
   ObjectSetTextMQL4(indiName+" "+symbolListFinal[symbolIndex]+" distanceL ",distance,fontText,Font,distanceColor);
  }
//+------------------------------------------------------------------+
void SetCrossFlag(int symbolIndex,int valueIndex)
  {
   double bid=SymbolInfoDouble(symbolListFinal[symbolIndex],SYMBOL_BID);

   if(symbolsRangeHiLoValues[symbolIndex][valueIndex]>bid)
     {
      symbolsCrossFlags[symbolIndex][valueIndex]=true;
     }
   else
     {
      symbolsCrossFlags[symbolIndex][valueIndex]=false;
     }
  }
//+------------------------------------------------------------------+
void CheckCrossFlag(int symbolIndex)
  {
   double bid=SymbolInfoDouble(symbolListFinal[symbolIndex],SYMBOL_BID);

   bool highResult=NULL;
   bool lowResult=NULL;

//high check
   if(symbolsCrossFlags[symbolIndex][0]!=NULL)
     {
      if(symbolsRangeHiLoValues[symbolIndex][0]>bid)
        {
         highResult=true;
        }
      else
        {
         highResult=false;
        }
     }
//low check
   if(symbolsCrossFlags[symbolIndex][1]!=NULL)
     {
      if(symbolsRangeHiLoValues[symbolIndex][1]>bid)
        {
         lowResult=true;
        }
      else
        {
         lowResult=false;
        }
     }
   if(highResult!=symbolsCrossFlags[symbolIndex][0])
     {
      symbolsCrossFlags[symbolIndex][0]=highResult;

      if(TimeCurrent()>=symbolsWaitTills[symbolIndex][0])
        {
         symbolsWaitTills[symbolIndex][0]=(TimeCurrent()+alertIntervalTimeSeconds);
         DoAlert(symbolIndex,0,0);
        }
     }
   if(lowResult!=symbolsCrossFlags[symbolIndex][1])
     {
      symbolsCrossFlags[symbolIndex][1]=lowResult;

      if(TimeCurrent()>=symbolsWaitTills[symbolIndex][1])
        {
         symbolsWaitTills[symbolIndex][1]=(TimeCurrent()+alertIntervalTimeSeconds);
         DoAlert(symbolIndex,1,0);
        }
     }
  }
//+------------------------------------------------------------------+
void DoAlert(int symbolIndex,int levelIndex,int alertType)
  {
//alertType 0=cross alert
//alertType 1=Percent Reached Alert
   //datetime timeOfAlert=NULL;
   string timeOfAlert=NULL;
   if(useDashboard==Yes)
     {
      if(timeChoiceOption==Local)
        {
         timeOfAlert=TimeLocal();
        }
      else
         if(timeChoiceOption==Server)
           {
            timeOfAlert=TimeCurrent();
           }

      TimeOfAlertLabelUpdate(symbolListFinal[symbolIndex],timeOfAlert);
     }

   string alertMsg="";
   string alertedMsg="";
   string recentListMsg="";

   if(alertType==0)
     {
      string levelName="";
      if(levelIndex==0)
        {
         levelName="High";
        }
      else
        {
         levelName="Low";
        }

      alertMsg=symbolListFinal[symbolIndex]+" "+timeFrameShortName+" "+levelName+" Crossed";
      alertedMsg=levelName;
      recentListMsg=symbolListFinal[symbolIndex]+" "+levelName+" Crossed"+"    "+TimeToString(timeOfAlert,TIME_DATE|TIME_SECONDS);
     }
   else
      if(alertType==1)
        {
         alertMsg=symbolListFinal[symbolIndex]+" "+timeFrameShortName+" "+DoubleToString(percentageValueAlert,decimalPlaces)+"% Reached";
         alertedMsg=DoubleToString(percentageValueAlert,decimalPlaces)+"%";
         recentListMsg=symbolListFinal[symbolIndex]+" "+DoubleToString(percentageValueAlert,decimalPlaces)+"% Reached"+"    "+TimeToString(timeOfAlert,TIME_DATE|TIME_SECONDS);
        }

   if(useDashboard==Yes)
     {
      ListLabels(symbolIndex,recentListMsg,alertedMsg);
     }
   if(popupAlerts==Yes)
     {
      Alert(alertMsg);
     }
   if(notificationAlerts==Yes)
     {
      SendNotification(alertMsg);
     }
   if(emailAlerts==Yes)
     {
      SendMail(alertMsg,alertMsg);
     }
  }
//+------------------------------------------------------------------+
void ListLabels(int symbolIndex,string alertedMsg,string listMsg)
  {
   color ppColor=clrNONE;

   for(int k=listLabelSize-1; k>=0; k--)
     {
      if(k>=1)
        {
         string oldText=ObjectDescriptionMQL4(indiName+" "+listLabelNames[k-1]);
         color oldColor=(color)ObjectGetInteger(0,indiName+" "+listLabelNames[k-1],OBJPROP_COLOR);
         ObjectSetTextMQL4(indiName+" "+listLabelNames[k],oldText,fontText,Font,oldColor);
        }
     }
   ObjectSetTextMQL4(indiName+" "+listLabelNames[0],alertedMsg,fontText,Font,listLabelColor);
   ObjectSetTextMQL4(indiName+" "+symbolListFinal[symbolIndex]+" alertedL ",listMsg,fontText,Font,alertColor);
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
void TimeOfAlertLabelUpdate(string symbol,datetime timeCurrent)
  {
   ObjectSetTextMQL4(indiName+" "+symbol+" timeLastAlertL ",TimeToString(timeCurrent,TIME_DATE|TIME_SECONDS),fontText,Font,timeLastAlertColor);
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
void CheckPercentFlag(int symbolIndex)
  {
   double value=GetAverageRangeRatioPipsPoints(symbolListFinal[symbolIndex]);
   if(value>=percentageValueAlert && symbolsRatioFlags[symbolIndex][0]==true)
     {
      DoAlert(symbolIndex,0,1);
      symbolsRatioFlags[symbolIndex][0]=false;
     }
   if(value<percentageValueAlert)
     {
      symbolsRatioFlags[symbolIndex][0]=true;
     }
   else
     {
      symbolsRatioFlags[symbolIndex][0]=false;
     }
  }
//+------------------------------------------------------------------+
//open symbol chart when click on symbol name
void OnChartEvent(const int id,         // Event identifier
                  const long& lparam,   // Event parameter of long type
                  const double& dparam, // Event parameter of double type
                  const string& sparam) // Event parameter of string type
  {
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      string sep=" ";                // A separator as a character
      ushort u_sep;                  // The code of the separator character
      string result[];               // An array to get strings

      string resultRecentAlerts[];

      //--- Get the separator code
      u_sep=StringGetCharacter(sep,0);

      int k=StringSplit(sparam,u_sep,result);

      int resultSize=ArraySize(result);

      if(resultSize==4)//Clicked symbol label
        {
         if(result[2]=="symbolL" && indiName==result[0])
           {
            long resultChartOpen = ChartOpen(result[1],openChartTimeFrame);
           }
        }
      /*
            for(int q=0; q<resultSize; q++)
              {
               Alert("result "+(string)q+" "+result[q]);
              }
      */
      if(resultSize==2)//clicked symbol name in recent list alerts
        {
         if(indiName==result[0])
           {
            string symbolName=(string)ObjectGetString(0,result[0]+" "+result[1],OBJPROP_TEXT);

            //gets string name from object text
            int j=StringSplit(symbolName,u_sep,resultRecentAlerts);
            int resultRecentAlertsSize=ArraySize(resultRecentAlerts);
            /*
                        for(int s=0; s<resultRecentAlertsSize; s++)
                          {
                           Alert("recent "+(string)s+" "+resultRecentAlerts[s]);
                          }
            */
            if(resultRecentAlertsSize==8)
              {
               long resultChartOpen = ChartOpen(resultRecentAlerts[0],openChartTimeFrame);
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
  
bool ObjectSetTextMQL4(string name,
                       string text,
                       int font_size,
                       string font="",
                       color text_color=CLR_NONE)
  {
   int tmpObjType=(int)ObjectGetInteger(0,name,OBJPROP_TYPE);
   if(tmpObjType!=OBJ_LABEL && tmpObjType!=OBJ_TEXT)
      return(false);
   if(StringLen(text)>0 && font_size>0)
     {
      if(ObjectSetString(0,name,OBJPROP_TEXT,text)==true
         && ObjectSetInteger(0,name,OBJPROP_FONTSIZE,font_size)==true)
        {
         if((StringLen(font)>0)
            && ObjectSetString(0,name,OBJPROP_FONT,font)==false)
            return(false);
         if(text_color>-1
            && ObjectSetInteger(0,name,OBJPROP_COLOR,text_color)==false)
            return(false);
         return(true);
        }
      return(false);
     }
   return(false);
  }
//+------------------------------------------------------------------+
string ObjectDescriptionMQL4MQL4(string name)
  {
   return(ObjectGetString(0,name,OBJPROP_TEXT));
  }
//+------------------------------------------------------------------+
double CopyBufferMQL4(int handle,int index,int shift)
  {
   double buf[];
   switch(index)
     {
      case 0:
         if(CopyBuffer(handle,0,shift,1,buf)>0)
            return(buf[0]);
         break;
      case 1:
         if(CopyBuffer(handle,1,shift,1,buf)>0)
            return(buf[0]);
         break;
      case 2:
         if(CopyBuffer(handle,2,shift,1,buf)>0)
            return(buf[0]);
         break;
      case 3:
         if(CopyBuffer(handle,3,shift,1,buf)>0)
            return(buf[0]);
         break;
      case 4:
         if(CopyBuffer(handle,4,shift,1,buf)>0)
            return(buf[0]);
         break;
      default:
         break;
     }
   return(EMPTY_VALUE);
  }
//+------------------------------------------------------------------+
string ObjectDescriptionMQL4(string name)
  {
   return(ObjectGetString(0,name,OBJPROP_TEXT));
  }